local TimeSinceLastUpdate = 0
local ButtonShown = false

local function GrowlerNotify()
end

local function GrowlerCheckCast(unit, spellName, rank, lineID, spellID)
	--if GetNumGroupMembers() > 0 and unit ~= 
	-- print(unit)
	-- print(spellName)
	-- print(spellID)
end

local function CreateButton()
	local Growler_Btn = CreateFrame("Button", "Growler_Btn", UIParent, "SecureActionButtonTemplate")
	Growler_Btn:SetAttribute("type","macro")
	Growler_Btn:SetAttribute("macrotext","/petautocaston [@party1,noexists] Growl\n/petautocastoff [@party1,exists] Growl")
	Growler_Btn:SetSize(65,65)
	Growler_Btn:SetPoint("CENTER",0,100)
	Growler_Btn:RegisterForClicks("AnyUp")
	local _, _, icon_texture = GetSpellInfo(2649)
	local Growler_Texture = Growler_Btn:CreateTexture(nil,"BACKGROUND",nil,-6)
	Growler_Texture:SetTexture(icon_texture)
	Growler_Texture:SetAllPoints(Growler_Btn)
	Growler_Btn:SetNormalTexture(Growler_Texture)
	Growler_Btn:SetAlpha(0)
end

local function CreateOptionsPanel()
	Growler.Options = CreateFrame("FRAME", "GrowlerOptions", Growler)
	Growler.Options.name = "Growler"
	Growler.Options.okay = function () Growler_on = Growler.Options.GrowlerOn:GetChecked() end
	Growler.Options.cancel = function ()  Growler.Options.GrowlerOn:SetChecked(Growler_on)  end
	
	Growler.Options.GrowlerOn = CreateFrame("CheckButton", "GrowlerOptionsOn", Growler.Options, "ChatConfigCheckButtonTemplate")
	Growler.Options.GrowlerOn:SetPoint("TOPLEFT", 10, -10);
	getglobal(Growler.Options.GrowlerOn:GetName() .. 'Text'):SetText("Growler On");
	
	InterfaceOptions_AddCategory(Growler.Options)
end

local function GrowlerShow()
	if not ButtonShown then
		Growler_Btn:SetAlpha(1)
		ActionButton_ShowOverlayGlow(Growler_Btn)
		PlaySoundKitID(12867)
		ButtonShown = true
	end
end

local function GrowlerHide()
	if ButtonShown then
		ActionButton_HideOverlayGlow(Growler_Btn)
		Growler_Btn:SetAlpha(0)
		PlaySoundKitID(33338)
		ButtonShown = false
	end
end

local function Update(self, elapsed)
    TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed
	
	if TimeSinceLastUpdate > 0.5 and Growler_on then
		TimeSinceLastUpdate = 0
		
		local autocastable, autostate = GetSpellAutocast("Growl")
		if ((GetNumGroupMembers() > 0 and autostate==true) or (GetNumGroupMembers() == 0 and autostate==false)) then
			GrowlerShow()
		else
			GrowlerHide()
		end
	elseif not Growler_on then
		GrowlerHide()
	end
end

function Growler_OnLoad(self, event,...)
    self:RegisterEvent("ADDON_LOADED")
end

function Growler_OnEvent(self, event, ...)	
	if event == "ADDON_LOADED" then
		if ... == "Growler" then
			if Growler_on == nil then Growler_on = true end
			self:UnregisterEvent("ADDON_LOADED")
			self:RegisterEvent("UNIT_SPELLCAST_START")
			Growler:SetScript("OnUpdate", Update)
			CreateButton()
			CreateOptionsPanel()
		end
	elseif event == "UNIT_SPELLCAST_START" then
		GrowlerCheckCast(...)
	end
end